﻿namespace PruferCode
{
    internal class Program
    {
        static void Main(string[] args)
        {
            string[] lines = File.ReadAllLines("InputForTreeRecovering.txt");
            int[] prufersCode = lines[0].Split(' ').Select(int.Parse).ToArray();
            int[] treeVertices = lines[1].Split(' ').Select(int.Parse).ToArray();

            string treeEdges = Prufer.TreeRecovering(prufersCode, treeVertices);

            File.WriteAllText("OutputForTreeRecovering.txt", treeEdges);

            Console.WriteLine(treeEdges);

            string inputTree = File.ReadAllText("InputTree.txt").Trim();
            string[] edgePairs = inputTree.Split(',');
            int[,] edges = new int[edgePairs.Length, 2];

            for (int i = 0; i < edgePairs.Length; i++) 
            {
                string[] vertices = edgePairs[i].Trim().Split(" ");
                edges[i, 0] = int.Parse(vertices[0]) - 1;
                edges[i, 1] = int.Parse(vertices[1]) - 1;
            }

            int n = edges.Cast<int>().Max() + 1;

            int[] pruferCode = Prufer.TreeToPrufer(edges, n);

            File.WriteAllText("OutputForTreeToPrufer.txt", string.Join(" ", pruferCode.Select(x => x + 1)));
        }
    }
}